#!/usr/bin/env python
""" Provide functionality for a C extension model

	WARNING: THIS FILE WAS GENERATED BY WRAPPERGENERATOR.PY
 	         DO NOT MODIFY THIS FILE, MODIFY sphere.h
 	         AND RE-RUN THE GENERATOR SCRIPT

    @author: Mathieu Doucet / UTK
    @contact: mathieu.doucet@nist.gov
"""

from sans.models.BaseComponent import BaseComponent
from sans_extension.c_models import CSphereModel
import copy    
    
class SphereModel(CSphereModel, BaseComponent):
    """ Class that evaluates a SphereModel model. 
    	This file was auto-generated from sphere.h.
    	Refer to that file and the structure it contains
    	for details of the model.
    	List of default parameters:
         scale           = 1e-006 
         radius          = 60.0 A
         contrast        = 1.0 A-2
         background      = 0.0 cm-1

    """
        
    def __init__(self):
        """ Initialization """
        
        # Initialize BaseComponent first, then sphere
        BaseComponent.__init__(self)
        CSphereModel.__init__(self)
        
        ## Name of the model
        self.name = "SphereModel"
        self.description= """P(q)=(scale/V)*[3V(scatter_sld-solvent_sld)*(sin(qR)-qRcos(qR))/(qR)^3]^(2)
		+bkg
		bkg: background level
		R: radius of the sphere
		V:The volume of the scatter
		scatter_sld: the scattering length density of the scatter
		solvent_sld: the scattering length density of the solvent"""
		## Parameter details [units, min, max]
        self.details = {}
        self.details['scale'] = ['', None, None]
        self.details['radius'] = ['A', None, None]
        self.details['contrast'] = ['A-2', None, None]
        self.details['background'] = ['cm-1', None, None]

   
    def clone(self):
        """ Return a identical copy of self """
        obj = SphereModel()
        obj.params = copy.deepcopy(self.params)
        return obj   
   
    def run(self, x = 0.0):
        """ Evaluate the model
            @param x: input q, or [q,phi]
            @return: scattering function P(q)
        """
        
        return CSphereModel.run(self, x)
   
    def runXY(self, x = 0.0):
        """ Evaluate the model in cartesian coordinates
            @param x: input q, or [qx, qy]
            @return: scattering function P(q)
        """
        
        return CSphereModel.runXY(self, x)
   
# End of file
